︠c2281a1a-5207-4bf5-9aa2-53ae6816c2b8︠
var('t f')

a = 1500*t+1
b = 5*sin(1400*t)-cos(14000*t+pi/6)
c = sin(40000*t)+2.5

sample_rate = 10000
samples = 20
bits = 8
total_time = (samples / sample_rate)
resol = 256
range = 5

reso_range = range/resol

lookup = {}

def adc(x,f):
    x = floor(x * sample_rate)/sample_rate
    if x in lookup:
        return lookup[x]
    else:
        n = max( min( floor( f(x)/reso_range ) ,255),0)*reso_range
        lookup[x] = n
        return n

def adc2(x,f):
    x = floor(x * sample_rate)/sample_rate
    if x in lookup:
        return lookup[x]
    else:
        n = max( min( floor( f(x)/reso_range ) ,255),0)
        lookup[x] = n
        return n

def getTable(f):
    s = "<table border=1><thead><tr><th>Sample</th><th>Time (sec.)</th><th>v(t) (volts)</th><th>ADC value</th><th>Voltage read by ADC</th></tr></thead><tbody>"
    for i in xrange(0,20):
        t = i / 10000
        v = f(t)
        d = adc2(t,f)
        e = d * reso_range
        s = s + "<tr><td>%d</td><td>%f</td><td>%f</td><td>%d</td><td>%f</td></tr>" % (i,t,v,d,e)
    s = s + "</tbody></table>"
    return s
︡5d874348-bdc6-487f-bc0a-a146fbe2ec33︡︡
︠cd08f469-faff-4afa-b0ad-dfb46d8abaf8︠
lookup = {}
show(plot(a(t),(0,total_time))+plot(lambda x: adc(x,a),(0,total_time),color="orange"),ymin=0,ymax=5,figsize=(8,10),dpi=75)
︡126d3ec5-136b-45ef-ab2b-9d4531d00fe3︡︡
︠0ec82e67-c166-407e-94d2-21372d572ecc︠
html(getTable(a))
︡1422f28f-cd04-419e-a348-94b5efcac5f2︡{"html": "<font color='black'><table border=1><thead><tr><th>Sample</th><th>Time (sec.)</th><th>v(t) (volts)</th><th>ADC value</th><th>Voltage read by ADC</th></tr></thead><tbody><tr><td>0</td><td>0.000000</td><td>1.000000</td><td>51</td><td>0.996094</td></tr><tr><td>1</td><td>0.000100</td><td>1.150000</td><td>58</td><td>1.132812</td></tr><tr><td>2</td><td>0.000200</td><td>1.300000</td><td>66</td><td>1.289062</td></tr><tr><td>3</td><td>0.000300</td><td>1.450000</td><td>74</td><td>1.445312</td></tr><tr><td>4</td><td>0.000400</td><td>1.600000</td><td>81</td><td>1.582031</td></tr><tr><td>5</td><td>0.000500</td><td>1.750000</td><td>89</td><td>1.738281</td></tr><tr><td>6</td><td>0.000600</td><td>1.900000</td><td>97</td><td>1.894531</td></tr><tr><td>7</td><td>0.000700</td><td>2.050000</td><td>104</td><td>2.031250</td></tr><tr><td>8</td><td>0.000800</td><td>2.200000</td><td>112</td><td>2.187500</td></tr><tr><td>9</td><td>0.000900</td><td>2.350000</td><td>120</td><td>2.343750</td></tr><tr><td>10</td><td>0.001000</td><td>2.500000</td><td>128</td><td>2.500000</td></tr><tr><td>11</td><td>0.001100</td><td>2.650000</td><td>135</td><td>2.636719</td></tr><tr><td>12</td><td>0.001200</td><td>2.800000</td><td>143</td><td>2.792969</td></tr><tr><td>13</td><td>0.001300</td><td>2.950000</td><td>151</td><td>2.949219</td></tr><tr><td>14</td><td>0.001400</td><td>3.100000</td><td>158</td><td>3.085938</td></tr><tr><td>15</td><td>0.001500</td><td>3.250000</td><td>166</td><td>3.242188</td></tr><tr><td>16</td><td>0.001600</td><td>3.400000</td><td>174</td><td>3.398438</td></tr><tr><td>17</td><td>0.001700</td><td>3.550000</td><td>181</td><td>3.535156</td></tr><tr><td>18</td><td>0.001800</td><td>3.700000</td><td>189</td><td>3.691406</td></tr><tr><td>19</td><td>0.001900</td><td>3.850000</td><td>197</td><td>3.847656</td></tr></tbody></table></font>"}︡
︠79b2c1a7-2eca-4521-810d-f88985b6abf3︠
lookup = {}
show(plot(c(t),(0,total_time))+plot(lambda x: adc(x,c),(0,total_time),color="orange"),ymin=0,ymax=5,figsize=(8,10),dpi=75)
︡0cbcf14d-2a48-4d71-b88d-795a0299191c︡︡
︠afbd9eb0-b99a-4aac-a309-13bf65b2ee93︠
lookup = {}
html(getTable(b))
︡8770a057-f6d9-497a-b7b4-1a3030e3ec2b︡{"html": "<font color='black'><table border=1><thead><tr><th>Sample</th><th>Time (sec.)</th><th>v(t) (volts)</th><th>ADC value</th><th>Voltage read by ADC</th></tr></thead><tbody><tr><td>0</td><td>0.000000</td><td>-0.866025</td><td>0</td><td>0.000000</td></tr><tr><td>1</td><td>0.000100</td><td>1.043245</td><td>53</td><td>1.035156</td></tr><tr><td>2</td><td>0.000200</td><td>2.365261</td><td>121</td><td>2.363281</td></tr><tr><td>3</td><td>0.000300</td><td>2.027593</td><td>103</td><td>2.011719</td></tr><tr><td>4</td><td>0.000400</td><td>1.668638</td><td>85</td><td>1.660156</td></tr><tr><td>5</td><td>0.000500</td><td>2.896683</td><td>148</td><td>2.890625</td></tr><tr><td>6</td><td>0.000600</td><td>4.600232</td><td>235</td><td>4.589844</td></tr><tr><td>7</td><td>0.000700</td><td>4.775020</td><td>244</td><td>4.765625</td></tr><tr><td>8</td><td>0.000800</td><td>3.835106</td><td>196</td><td>3.828125</td></tr><tr><td>9</td><td>0.000900</td><td>3.911727</td><td>200</td><td>3.906250</td></tr><tr><td>10</td><td>0.001000</td><td>5.304134</td><td>255</td><td>4.980469</td></tr><tr><td>11</td><td>0.001100</td><td>5.974470</td><td>255</td><td>4.980469</td></tr><tr><td>12</td><td>0.001200</td><td>4.925392</td><td>252</td><td>4.921875</td></tr><tr><td>13</td><td>0.001300</td><td>3.853468</td><td>197</td><td>3.847656</td></tr><tr><td>14</td><td>0.001400</td><td>4.333640</td><td>221</td><td>4.316406</td></tr><tr><td>15</td><td>0.001500</td><td>5.208722</td><td>255</td><td>4.980469</td></tr><tr><td>16</td><td>0.001600</td><td>4.517448</td><td>231</td><td>4.511719</td></tr><tr><td>17</td><td>0.001700</td><td>2.760256</td><td>141</td><td>2.753906</td></tr><tr><td>18</td><td>0.001800</td><td>2.081190</td><td>106</td><td>2.070312</td></tr><tr><td>19</td><td>0.001900</td><td>2.723773</td><td>139</td><td>2.714844</td></tr></tbody></table></font>"}︡
︠095232d1-6ccb-4697-81f9-1ec65389f440︠
lookup = {}
show(plot(b(t),(0,total_time))+plot(lambda x: adc(x,b),(0,total_time),color="orange"),figsize=(8,10),dpi=75)
︡e85b949e-90c2-4936-9ef0-295ffbf19407︡︡
︠97d6a15c-e6f1-4963-8a3b-283edf7efd4f︠
lookup = {}
html(getTable(c))
︡1862ba28-7898-4474-9bad-fa739a6133ed︡{"html": "<font color='black'><table border=1><thead><tr><th>Sample</th><th>Time (sec.)</th><th>v(t) (volts)</th><th>ADC value</th><th>Voltage read by ADC</th></tr></thead><tbody><tr><td>0</td><td>0.000000</td><td>2.500000</td><td>128</td><td>2.500000</td></tr><tr><td>1</td><td>0.000100</td><td>1.743198</td><td>89</td><td>1.738281</td></tr><tr><td>2</td><td>0.000200</td><td>3.489358</td><td>178</td><td>3.476562</td></tr><tr><td>3</td><td>0.000300</td><td>1.963427</td><td>100</td><td>1.953125</td></tr><tr><td>4</td><td>0.000400</td><td>2.212097</td><td>113</td><td>2.207031</td></tr><tr><td>5</td><td>0.000500</td><td>3.412945</td><td>174</td><td>3.398438</td></tr><tr><td>6</td><td>0.000600</td><td>1.594422</td><td>81</td><td>1.582031</td></tr><tr><td>7</td><td>0.000700</td><td>2.770906</td><td>141</td><td>2.753906</td></tr><tr><td>8</td><td>0.000800</td><td>3.051427</td><td>156</td><td>3.046875</td></tr><tr><td>9</td><td>0.000900</td><td>1.508221</td><td>77</td><td>1.503906</td></tr><tr><td>10</td><td>0.001000</td><td>3.245113</td><td>166</td><td>3.242188</td></tr><tr><td>11</td><td>0.001100</td><td>2.517702</td><td>128</td><td>2.500000</td></tr><tr><td>12</td><td>0.001200</td><td>1.731745</td><td>88</td><td>1.718750</td></tr><tr><td>13</td><td>0.001300</td><td>3.486628</td><td>178</td><td>3.476562</td></tr><tr><td>14</td><td>0.001400</td><td>1.978449</td><td>101</td><td>1.972656</td></tr><tr><td>15</td><td>0.001500</td><td>2.195189</td><td>112</td><td>2.187500</td></tr><tr><td>16</td><td>0.001600</td><td>3.420026</td><td>175</td><td>3.417969</td></tr><tr><td>17</td><td>0.001700</td><td>1.602072</td><td>82</td><td>1.601562</td></tr><tr><td>18</td><td>0.001800</td><td>2.753823</td><td>140</td><td>2.734375</td></tr><tr><td>19</td><td>0.001900</td><td>3.066108</td><td>156</td><td>3.046875</td></tr></tbody></table></font>"}︡
